<template>
    <div>
        <h1>Ticket Details</h1>
        <div v-if="ticket && creatorUser && assingedUser" class="ticket">
            <template>
                <v-card
                        class="mx-auto my-12"
                        max-width="374"
                >
                    <template slot="progress">
                        <v-progress-linear
                                color="deep-purple"
                                height="10"
                                indeterminate
                        ></v-progress-linear>
                    </template>
                    <v-card-title> Ticket {{ticket.ticketNumber}}</v-card-title>
                    <v-divider class="mx-4"></v-divider>

                    <v-card-title>Title</v-card-title>
                    <v-card-text>{{ticket.title}}</v-card-text>
                    <v-divider class="mx-4"></v-divider>
                    <v-card-title>Creator</v-card-title>

                    <v-list-item-avatar color="grey darken-3">
                        <img
                                class="elevation-6"
                                alt=""
                                :src="creatorUser.profileImage"
                        >
                    </v-list-item-avatar>
                    <v-list-item-content>
                        <v-list-item-title>{{ creatorUser.firstname }}  {{ creatorUser.lastname}}</v-list-item-title>
                    </v-list-item-content>
                    <v-card-title>AssignedTo</v-card-title>
                    <v-list-item-avatar color="grey darken-3">
                        <img
                                class="elevation-6"
                                alt=""
                                :src="assingedUser.profileImage"
                        >
                    </v-list-item-avatar>

                    <v-list-item-content>
                        <v-list-item-title>{{ assingedUser.firstname }}  {{ assingedUser.lastname}}</v-list-item-title>
                    </v-list-item-content>
                    <v-card-title>Descritpion</v-card-title>
                    <v-card-text>{{ticket.description}}</v-card-text>
                    <v-divider class="mx-4"></v-divider>
                    <div style="display: flex;justify-content: space-evenly;font-size: 0.8em">
                        <div>
                            <v-icon class="mr-1">
                                mdi-treasure-chest
                            </v-icon>
                            <span class="subheading">{{ticket.point}}</span>
                        </div>
                        <div>
                            <v-icon class="mr-1">
                                mdi-calendar
                            </v-icon>
                            <span class="subheading">{{ticket.createdDate}}</span>
                        </div>

                    </div>

                    <div>
                        <button @click="deleteTicket">
                            <v-icon class="mr-1" >
                                mdi-delete
                            </v-icon>
                        </button>
                        <router-link :to="`/tickets/${ticket.id}/update`" style="text-decoration: none; color : inherit">
                            <v-icon>mdi-update</v-icon>
                        </router-link>
                    </div>
                </v-card>
            </template>
        </div>
        <span v-else> Oops ticket not found</span>
        <label v-if="error">{{error}}</label>
    </div>
</template>

<script>
  import TicketsServices from "@/services/ticket.js";
  import UsersServices from "../services/user";

  // import { format,parse } from 'date-fns';

  export default {
    name: "TicketDetail",

    async beforeCreate(){
      this.ticket = await TicketsServices.getTicket( this.$route.params.id );
      this.creatorUser=  await UsersServices.getUser(this.ticket.creator);
      this.assingedUser=  await UsersServices.getUser(this.ticket.assignedTo);
      console.log(this.ticket.createdDate)
      // console.log(format(parse(this.ticket.createdDate,'dd/MM/yyyy',new Date())))

    },
    data(){
      return{
        ticket:null,
        creatorUser:null,
        assingedUser:null,
        error : null
      }
    },
    methods:{
      async deleteTicket(){
        try {
          await TicketsServices.deleteTicket(this.$route.params.id);
          this.$router.push('/');
        } catch (e) {
          this.error = 'Oops there is a problem !';
        }
      }
    }
  }
</script>

<style scoped>
    .ticket{
        display: flex;
        justify-content: center;
    }
</style>